﻿using System;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            //SyncRead();
            //AsyncRead();

            AwaitRead();
            Console.ReadLine();
        }

        void NormalFunc() // 만약 이 메소드에 async 예약어를 적용하면 컴파일 오류 발생
        {
            int await = 5;
            Console.WriteLine(await);
        }

        private static async void AwaitRead()
        {
            using (FileStream fs =
                        new FileStream(@"C:\windows\system32\drivers\etc\HOSTS", FileMode.Open))
            {
                byte[] buf = new byte[fs.Length];
                Console.WriteLine("Before ReadAsync: " + Thread.CurrentThread.ManagedThreadId);
                await fs.ReadAsync(buf, 0, buf.Length);
                Console.WriteLine("After ReadAsync: " + Thread.CurrentThread.ManagedThreadId);

                string txt = Encoding.UTF8.GetString(buf);
                Console.WriteLine(txt);
            }
        }

        private static void SyncRead()
        {
            using (FileStream fs =
                        new FileStream(@"C:\windows\system32\drivers\etc\HOSTS", FileMode.Open))
            {
                byte[] buf = new byte[fs.Length];
                fs.Read(buf, 0, buf.Length);

                string txt = Encoding.UTF8.GetString(buf);
                Console.WriteLine(txt);
            }
        }

        class FileState
        {
            public byte[] Buffer;
            public FileStream File;
        }

        private static void AsyncRead()
        {
            FileStream fs =
                new FileStream(@"C:\windows\system32\drivers\etc\HOSTS", FileMode.Open);

            FileState state = new FileState();
            state.Buffer = new byte[fs.Length];
            state.File = fs;

            fs.BeginRead(state.Buffer, 0, state.Buffer.Length, readCompleted, state);

            Console.ReadLine();
            fs.Close();
        }

        // 읽기 작업이 완료되면 메소드가 호출된다.
        static void readCompleted(IAsyncResult ar)
        {
            FileState state = ar.AsyncState as FileState;
            state.File.EndRead(ar);

            string txt = Encoding.UTF8.GetString(state.Buffer);
            Console.WriteLine(txt);
        }
    }
}
